part of testlist;

RandomList corridorList = new RandomList("CORRIDOR_LIST");
RandomList roomList = new RandomList("ROOM_LIST");
RandomList emptyRoomList = new RandomList("EMPTY_ROOM_LIST"); // child list
RandomList monsterList = new RandomList("MONSTER_LIST");
RandomList treasureList = new RandomList("TREASURE_LIST");
RandomList superTreasureList = new RandomList("SUPER_TREASURE_LIST");
RandomList combatList = new RandomList("COMBAT_LIST");

Map allLists = new Map();

Map allFilters = new Map();

initLists() {
  print("init lists");

  allLists["CORRIDOR_LIST"] = corridorList;
  allLists["ROOM_LIST"] = roomList;
  allLists["MONSTER_LIST"] = monsterList;
  allLists["COMBAT_LIST"] = combatList;
  allLists["TREASURE_LIST"] = treasureList;
  allLists["SUPER_TREASURE_LIST"] = superTreasureList;


  corridorList.add("BASIC_SHORT", obj:"You walk down a short corridor and enter a room...", userData:"ROOM_LIST");
  corridorList.add("BASIC_LONG", obj:"You walk down a long corridor and go into a room...", userData:"ROOM_LIST");
  corridorList.add("BASIC_WIDE", obj:"You walk down a wide corridor that ends in a room...", userData:"ROOM_LIST");
  corridorList.add("BASIC_NARROW", obj:"You walk down a narrow corridor and come to a room...", userData:"ROOM_LIST");

  emptyRoomList.add("CHEESE", obj:"There is nothing in this room but some old cheese.", userData:"CORRIDOR_LIST", lifetime:1);
  emptyRoomList.add("RATS", obj:"Rats scurry away into the corners of this empty room.", userData:"CORRIDOR_LIST", weightDecrease:20);
  emptyRoomList.add("STILL", obj:"The room is empty except for stale air.", userData:"CORRIDOR_LIST", weightDecrease:20);
  emptyRoomList.add("LONELY", obj:"The emptiness of this room reminds you of the emptiness of your own soul.", userData:"CORRIDOR_LIST", weightDecrease:20);
  emptyRoomList.add("SEENONE", obj:"If you've seen one empty room, you've seen them all.", userData:"CORRIDOR_LIST", weightDecrease:20);
  emptyRoomList.add("CLEAN", obj:"This empty room is suspiciously clean.", userData:"CORRIDOR_LIST", weightDecrease:20);
  emptyRoomList.add("DIRTY", obj:"This empty room is filthy.", userData:"CORRIDOR_LIST", weightDecrease:20);

  monsterList.add("ORCUS", obj:"You confront Orcus, master of demons", lifetime:1, weight:1, weightIncrease: 2, userData:"COMBAT_LIST");
  monsterList.add("SPIDER", obj:"You are attacked by a giant spider", weightDecrease:20, userData:"COMBAT_LIST" );
  monsterList.add("SKELETON", obj:"You are attacked by a creaky skeleton.", weightDecrease:20, userData:"COMBAT_LIST" );
  monsterList.add("ORC", obj:"A stinky orc surprises you!", weightDecrease:20, userData:"COMBAT_LIST" );
  monsterList.add("SNAKE", obj:"A giant snake sssssurprisesss you!", weightDecrease:20, userData:"COMBAT_LIST" );
  monsterList.add("ROACHES", obj:"Roaches!", weightDecrease:20, userData:"COMBAT_LIST" );

  combatList.add("HIT1", obj:"You hit the creature.", userData:"COMBAT_LIST" );
  combatList.add("HIT2", obj:"You hit the creature.", userData:"COMBAT_LIST" );
  combatList.add("HIT3", obj:"You hit the creature.", userData:"COMBAT_LIST" );
  combatList.add("HIT4", obj:"You hit the creature, killing it!", userData:"TREASURE_LIST" );

  superTreasureList.add("GRAIL", obj: "You find the holy grail!", userData:"CORRIDOR_LIST");


  treasureList.add("BEANIE", obj:"You find a beanie ringed with ermine.", userData:"CORRIDOR_LIST");
  treasureList.add("DBUNNY", obj: "You find an obsidian dust bunny.", userData:"CORRIDOR_LIST");
  treasureList.add("GOLD", obj: "450 gold!", userData:"CORRIDOR_LIST");
  treasureList.add("GOLD2", obj: "75 gold pieces!", userData:"CORRIDOR_LIST");
  treasureList.add("SILVER", obj: "You find 2.7 silver pieces!", userData:"CORRIDOR_LIST");
  treasureList.add("SUPER", obj:superTreasureList, userData:"CORRIDOR_LIST", weight:10);
  treasureList.add("WAND", obj: "You find a magic wand!", lifetime:1, weight:500, userData:"CORRIDOR_LIST");
  treasureList.add("OIL", obj: "You find a flask of oil", lifetime:1, weight:500, userData:"CORRIDOR_LIST");

  // room
  roomList.add("EMPTY", obj:emptyRoomList, weightDecrease:20);
  roomList.add("MONSTER", obj:monsterList, weightDecrease:20);
  roomList.add("TREASURE", obj:monsterList, weightDecrease:20, weight:20);


  var filter = ( RandomListItem item, int attemptsRemaining, RandomListFilterCallback callback) {
     print("***** filtering treasure table");

     // a simple filter that only allows certain 'classes' to get certain items

     if(item.id == "OIL")  {
       if( charClass == "THIEF") {
         callback(item, true);
       } else {
         callback(item, false);
       }

     } else

     if(item.id == "WAND") {
       if( charClass == "MAGE") {
         callback(item, true);
              } else {
         callback(item, false);
              }
     } else

     callback(item, true);
  };

  allFilters["TREASURE_LIST" ] = filter;

} // initLists()